unit Machine;

interface

uses
  Classes, SysUtils, CpuBitWidth, Memory, SerialPort;

type

  { TMachine }

  TMachine1 = class
  public
    Cpu: TCpuBitWidth1;
    Memory: TMemory1;
    VideoMemory: TMemory1;
    SystemMemory: TMemory1;
    SerialPort: TSerialPort1;
    constructor Create;
    destructor Destroy; override;
  end;

  { TMachine2 }

  TMachine2 = class
  public
    Cpu: TCpuBitWidth2;
    Memory: TMemory2;
    VideoMemory: TMemory2;
    SystemMemory: TMemory2;
    SerialPort: TSerialPort2;
    constructor Create;
    destructor Destroy; override;
  end;

implementation

{ TMachine2 }

constructor TMachine2.Create;
begin
  Memory := TMemory2.Create;
  VideoMemory := TMemory2.Create;
  SystemMemory := TMemory2.Create;
  SerialPort := TSerialPort2.Create;
  Cpu := TCpuBitWidth2.Create;
  Cpu.IO := SerialPort;
  Cpu.Memory := Memory;
end;

destructor TMachine2.Destroy;
begin
  FreeAndNil(SerialPort);
  FreeAndNil(Cpu);
  FreeAndNil(SystemMemory);
  FreeAndNil(VideoMemory);
  FreeAndNil(Memory);
  inherited;
end;

{ TMachine }

constructor TMachine1.Create;
begin
  Memory := TMemory1.Create;
  VideoMemory := TMemory1.Create;
  SystemMemory := TMemory1.Create;
  SerialPort := TSerialPort1.Create;
  Cpu := TCpuBitWidth1.Create;
  Cpu.IO := SerialPort;
  Cpu.Memory := Memory;
end;

destructor TMachine1.Destroy;
begin
  FreeAndNil(SerialPort);
  FreeAndNil(Cpu);
  FreeAndNil(SystemMemory);
  FreeAndNil(VideoMemory);
  FreeAndNil(Memory);
  inherited;
end;

end.

