unit Memory;

interface

uses
  Classes, SysUtils, AddressableArea;

type
  { TMemory1 }

  TMemory1 = class(TAddressableArea1)
  private
    FSize: Integer;
    FData: PByte;
    procedure SetSize(AValue: Integer);
  public
    procedure Write1(Address: Byte; Data: Byte); override;
    function Read1(Address: Byte): Byte; override;
    property Data: PByte read FData;
    property Size: Integer read FSize write SetSize;
  end;

  { TMemory2 }

  TMemory2 = class(TAddressableArea2)
  private
    FSize: Integer;
    FData: PByte;
    procedure SetSize(AValue: Integer);
  public
    procedure Write1(Address: Word; Data: Byte); override;
    procedure Write2(Address: Word; Data: Word); override;
    function Read1(Address: Word): Byte; override;
    function Read2(Address: Word): Word; override;
    property Data: PByte read FData;
    property Size: Integer read FSize write SetSize;
  end;


implementation

{ TMemory2 }

procedure TMemory2.SetSize(AValue: Integer);
begin
  if FSize = AValue then Exit;
  FSize := AValue;
  FData := ReAllocMem(FData, FSize);
end;

procedure TMemory2.Write1(Address: Word; Data: Byte);
begin
  (FData + Address)^ := Data;
end;

procedure TMemory2.Write2(Address: Word; Data: Word);
begin
  PWord(FData + Address)^ := Data;
end;

function TMemory2.Read1(Address: Word): Byte;
begin
  Result := (FData + Address)^;
end;

function TMemory2.Read2(Address: Word): Word;
begin
  Result := PWord(FData + Address)^;
end;

{ TMemory1 }

procedure TMemory1.SetSize(AValue: Integer);
begin
  if FSize = AValue then Exit;
  FSize := AValue;
  FData := ReAllocMem(FData, FSize);
end;

procedure TMemory1.Write1(Address: Byte; Data: Byte);
begin
  (FData + Address)^ := Data;
end;

function TMemory1.Read1(Address: Byte): Byte;
begin
  Result := (FData + Address)^;
end;

end.

